namescreenbuttons:
push	r4,r7,r14
ldr	r4,=200FC40h
mov	r3,r10
ldr	r3,[r3,4h]
ldrh	r3,[r3,2h]
mov	r0,2h
tst	r3,r0
beq	@@Bnotpressed

@@Bpressed:
ldr	r3,[r4,14h]
ldr	r2,[r4,10h]
cmp	r2,r3
bne	@@eraseback
ldr	r2,[r4,18h]
cmp	r2,r3
beq	@@endinput
add	r2,r3,2h
b	@@moveback

@@endinput:
ldrb	r0,[r4,0Eh]
cmp	r0,2h
beq	@@cannotend

@@quitinput:
mov	r0,2h
strb	r0,[r4,0Eh]
mov	r0,7Fh
ldr	r7,=8000535h
mov	r14,r15
bx	r7
mov	r0,0h
strb	r0,[r5,0Ah]
mov	r0,14h
strb	r0,[r5]
mov	r0,1h
pop	r4,r7,r15

@@cannotend:
ldrb	r0,[r4,6h]
cmp	r0,0Fh
bne	@@jumptoend
ldrb	r0,[r4,7h]
cmp	r0,05h
bne	@@jumptoend
mov	r0,1h
pop	r4,r7,r15

@@jumptoend:
mov	r0,0Fh
strb	r0,[r4,6h]
mov	r0,5h
strb	r0,[r4,7h]
b	@@playswitchsound

@@eraseback:
mov	r2,r3
sub	r3,2h
str	r3,[r4,14h]

@@moveback:
ldr	r1,[r4,18h]
cmp	r1,r2
beq	@@stopmoveback
@@movebackloop:
ldrh	r0,[r2]
strh	r0,[r3]
add	r2,2h
add	r3,2h
cmp	r2,r1
bne	@@movebackloop
@@stopmoveback:
str	r3,[r4,18h]

@@playbacksound:
mov	r0,7Fh
ldr	r7,=8000535h
mov	r14,r15
bx	r7
mov	r0,1h
pop	r4,r7,r15

@@Bnotpressed:
mov	r0,1h
tst	r3,r0
bne	@@Apressed

@@Anotpressed:
mov	r0,8h
tst	r3,r0
bne	@@button4jump

@@STARTnotpressed:
mov	r0,2h
lsl	r0,r0,8h
tst	r3,r0
bne	@@cursorbackjump

@@Lnotpressed:
mov	r0,1h
lsl	r0,r0,8h
tst	r3,r0
bne	@@cursornext

@@Rnotpressed:
mov	r0,4h
tst	r3,r0
bne	@@button0

@@SELECTnotpressed:
mov	r0,0h
pop	r4,r7,r15

@@Apressed:
ldrb	r0,[r4,6h]
cmp	r0,0Fh
bne	@@normalkeyinput
ldrb	r0,[r4,7h]
cmp	r0,0h
bne	@@button1
b	@@button0

@@normalkeyinput:
mov	r0,14h
ldr	r7,=8035621h
mov	r14,r15
bx	r7
ldrb	r1,[r4,4h]
cmp	r0,r1
bge	@@jumptoOK
ldrb	r0,[r4,7h]
mov	r1,0Fh
mul	r0,r1
ldrb	r1,[r4,6h]
add	r1,r1,r0
ldr	r3,=@@inputtableoffsets
ldrb	r2,[r4,8h]
lsl	r2,r2,2h
ldr	r3,[r3,r2]

@@getcharloop:
tst	r1,r1
beq	@@insertcharacter
ldrb	r0,[r3]
cmp	r0,0E4h
bne	@@noextcharmap
add	r3,1h

@@noextcharmap:
add	r3,1h
sub	r1,1h
b	@@getcharloop

@@insertcharacter:
push	r3
ldr	r1,[r4,14h]
ldr	r2,[r4,18h]
cmp	r1,r2
bne	@@stopinsert
add	r2,2h
str	r2,[r4,18h]

@@stopinsert:
pop	r3
ldr	r2,[r4,14h]
ldrb	r0,[r3]
strh	r0,[r2]
cmp	r0,0E4h
bne	@@notinsertextchar
ldrb	r0,[r3,1h]
strb	r0,[r2,1h]

@@notinsertextchar:
add	r2,2h
str	r2,[r4,14h]
ldrb	r0,[r3]
cmp	r0,0h
bne	@@playinputsound
mov	r0,0D3h
add	r0,0FFh
b	@@playsound

@@playinputsound:
mov	r0,7Eh

@@playsound:
ldr	r7,=8000535h
mov	r14,r15
bx	r7
mov	r0,1h
pop	r4,r7,r15

@@quitinputjump:
b	@@quitinput

@@button0:
ldrb	r0,[r4,8h]
mov	r1,1h
eor	r0,r1
strb	r0,[r4,8h]
ldr	r7,=80356D1h
mov	r14,r15
bx	r7
b	@@playswitchsound

@@button4jump:
b	@@button4

@@button1:
cmp	r0,1h
bne	@@button2
ldr	r3,[r4,14h]
ldr	r2,[r4,10h]
cmp	r2,r3
bne	@@charswap
mov	r0,1h
pop	r4,r7,r15

@@charswap:
sub	r3,2h
ldrh	r0,[r3]
ldr	r1,=@@charswaptable

@@charswaploop:
ldrb	r2,[r1]
cmp	r2,0FFh
bne	@@charswapnotend
mov	r0,1h
pop	r4,r7,r15

@@cursorbackjump:
b	@@cursorback

@@charswapnotend:
cmp	r2,0E4h
bne	@@charswapnotext
add	r1,1h
ldrb	r2,[r1]
lsl	r2,r2,8h
add	r2,0E4h

@@charswapnotext:
cmp	r0,r2
beq	@@docharswap
ldrb	r2,[r1,1h]
add	r1,2h
cmp	r2,0E4h
bne	@@charswaploop
add	r1,1h
b	@@charswaploop

@@docharswap:
ldrb	r0,[r1,1h]
cmp	r0,0E4h
bne	@@storecharswap
ldrb	r0,[r1,2h]
lsl	r0,r0,8h
add	r0,0E4h

@@storecharswap:
strh	r0,[r3]
b	@@playswitchsound

@@button2:
cmp	r0,2h
bne	@@button3
b	@@cursornext

@@button3:
cmp	r0,3h
bne	@@button5
b	@@cursorback

@@cursornext:
ldr	r3,[r4,14h]
ldr	r2,[r4,18h]
cmp	r2,r3
beq	@@insertspace
add	r3,2h
str	r3,[r4,14h]
b	@@playswitchsound

@@insertspace:
mov	r0,14h
ldr	r7,=8035621h
mov	r14,r15
bx	r7
ldrb	r1,[r4,4h]
cmp	r0,r1
bge	@@jumptoOK
ldr	r3,=@@zeroaddress
b	@@insertcharacter

@@jumptoOK:
ldrb	r0,[r4,6h]
cmp	r0,0Fh
bne	@@realjumptoOK
ldrb	r0,[r4,7h]
cmp	r0,4h
bne	@@realjumptoOK
mov	r0,1h
pop	r4,r7,r15

@@realjumptoOK:
mov	r0,0Fh
strb	r0,[r4,6h]
mov	r0,4h
strb	r0,[r4,7h]
b	@@playswitchsound

@@cursorback:
ldr	r3,[r4,14h]
ldr	r2,[r4,10h]
cmp	r2,r3
beq	@@playswitchsoundreturn
ldr	r2,[r4,18h]
cmp	r2,r3
bne	@@realcursorback
sub	r3,2h
str	r3,[r4,14h]
ldrh	r0,[r3]
cmp	r0,0h
bne	@@playswitchsound
mov	r0,0B2h
strh	r0,[r3]
str	r3,[r4,18h]
b	@@playswitchsound

@@realcursorback:
sub	r3,2h
str	r3,[r4,14h]

@@playswitchsound:
mov	r0,0D3h
add	r0,0FFh
ldr	r7,=8000535h
mov	r14,r15
bx	r7

@@playswitchsoundreturn:
mov	r0,1h
pop	r4,r7,r15

@@button5:
cmp	r0,5h
bne	@@button4
ldrb	r0,[r4,0Eh]
cmp	r0,2h
bne	@@quitinputjump
ldr	r0,[r4,1Ch]
ldrb	r1,[r0]
cmp	r1,0h
bne	@@endbutton
mov	r0,69h
ldr	r7,=8000535h
mov	r14,r15
bx	r7
mov	r0,1h
pop	r4,r7,r15

@@endbutton:
add	r0,1h
ldr	r1,[r4,10h]
ldrb	r2,[r4,4h]
sub	r2,1h
lsl	r2,r2,1h
mov	r3,0B2h

@@fillemptyloop:
strh	r3,[r1,r2]
beq	@@copyoldinput
sub	r2,2h
b	@@fillemptyloop

@@copyoldinput:
ldrb	r2,[r0]
cmp	r2,0E5h
beq	@@stopcopying
cmp	r2,0E4h
bne	@@noextchar
add	r0,1h
ldrb	r3,[r0]
lsl	r3,r3,8h
add	r2,r2,r3

@@noextchar:
strh	r2,[r1]
add	r0,1h
add	r1,2h
b	@@copyoldinput

@@stopcopying:
str	r1,[r4,14h]
str	r1,[r4,18h]
ldr	r3,=803562Dh
mov	r14,r15
bx	r3
b	@@confirmation

@@button4:
ldrb	r0,[r4,6h]
cmp	r0,0Fh
bne	@@jumptoOK
ldrb	r0,[r4,7h]
cmp	r0,4h
bne	@@jumptoOK

@@confirmation:
ldr	r7,=8035039h
mov	r14,r15
bx	r7
beq	@@playOKsound
mov	r0,69h
ldr	r7,=8000535h
mov	r14,r15
bx	r7
mov	r1,4h
mov	r0,0Bh
b	@@confirm

@@playOKsound:
mov	r0,0D4h
add	r0,0FFh
ldr	r7,=8000535h
mov	r14,r15
bx	r7
mov	r1,0h
mov	r0,0Ah

@@confirm:
mov	r2,10h
strb	r2,[r5]
strb	r1,[r5,1h]
ldr	r7,=80322CDh
mov	r14,r15
bx	r7
mov	r0,1h
pop	r4,r7,r15

.pool
@@zeroaddress:
dcd	0x00000000

@@inputtableoffsets:
dcd	@@inputtableuppercase
dcd	@@inputtablelowercase

@@inputtableuppercase:
.import	misc\namescreen\uppercasecharmap.bin

@@inputtablelowercase:
.import	misc\namescreen\lowercasecharmap.bin

@@charswaptable:
dcb 0x0B,0x4B
dcb 0x4B,0x4C
dcb 0x4C,0x4D
dcb 0x4D,0x4E
dcb 0x4E,0x4F
dcb 0x4F,0x0B
dcb 0x0D,0x50
dcb 0x50,0x0D
dcb 0x0F,0x51
dcb 0x51,0x52
dcb 0x52,0x53
dcb 0x53,0x54
dcb 0x54,0x0F
dcb 0x13,0x55
dcb 0x55,0x56
dcb 0x56,0x57
dcb 0x57,0x58
dcb 0x58,0x13
dcb 0x18,0x59
dcb 0x59,0x18
dcb 0x19,0x5A
dcb 0x5A,0x5B
dcb 0x5B,0x5C
dcb 0x5C,0x5D
dcb 0x5D,0x5E
dcb 0x5E,0x19
dcb 0x1F,0x60
dcb 0x60,0x61
dcb 0x61,0x62
dcb 0x62,0x63
dcb 0x63,0x1F
dcb 0x23,0x64
dcb 0x64,0x23
dcb 0x26,0x65
dcb 0x65,0x66
dcb 0x66,0x67
dcb 0x67,0x68
dcb 0x68,0x69
dcb 0x69,0x26
dcb 0x28,0x6A
dcb 0x6A,0x28
dcb 0x2A,0x6B
dcb 0x6B,0x6C
dcb 0x6C,0x6D
dcb 0x6D,0x6E
dcb 0x6E,0x2A
dcb 0x2E,0x6F
dcb 0x6F,0x70
dcb 0x70,0x71
dcb 0x71,0x72
dcb 0x72,0x2E
dcb 0x33,0x73
dcb 0x73,0x33
dcb 0x34,0x74
dcb 0x74,0x75
dcb 0x75,0x76
dcb 0x76,0x77
dcb 0x77,0x78
dcb 0x78,0x34
dcb 0x3A,0x7A
dcb 0x7A,0x7B
dcb 0x7B,0x7C
dcb 0x7C,0x7D
dcb 0x7D,0x3A
dcb 0x3E,0x7E
dcb 0x7E,0x3E
dcb 0xFF,0x00
 ; eof